#ifdef USE_PRAGMA_IDENT_SRC
#pragma ident "@(#)register_definitions_sparc.cpp	1.12 07/05/05 17:04:31 JVM"
#endif
/*
 * Copyright 2002-2005 Sun Microsystems, Inc.  All Rights Reserved.
 * Copyright 2007-2008 Reservoir Labs, Inc.  All Rights Reserved.
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
 *
 * This code is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License version 2 only, as
 * published by the Free Software Foundation.
 *
 * This code is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 * version 2 for more details (a copy is included in the LICENSE file that
 * accompanied this code).
 *
 * You should have received a copy of the GNU General Public License version
 * 2 along with this work; if not, write to the Free Software Foundation,
 * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
 *
 * Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa Clara,
 * CA 95054 USA or visit www.sun.com if you need additional information or
 * have any questions.
 *  
 */

// make sure the defines don't screw up the declarations later on in this file
// YYY TODO: try to ditch per-register global variables and use
// #define S3 AS_REGISTER(Register, S3) and such.
// (Will need redefinitions of REGISTER_DECLARATION macros.  See register.hpp
//  for potential issues with this: (a) poorer support in gdb, and (b) growth
//  of the size of compiled code.)
#define DONT_USE_REGISTER_DEFINES

#include "incls/_precompiled.incl"
#include "incls/_register_definitions_mips.cpp.incl"

// hardware register names

REGISTER_DEFINITION(Register, noreg);

REGISTER_DEFINITION(Register, R0);
REGISTER_DEFINITION(Register, R1);
REGISTER_DEFINITION(Register, R2);
REGISTER_DEFINITION(Register, R3);
REGISTER_DEFINITION(Register, R4);
REGISTER_DEFINITION(Register, R5);
REGISTER_DEFINITION(Register, R6);
REGISTER_DEFINITION(Register, R7);
REGISTER_DEFINITION(Register, R8);
REGISTER_DEFINITION(Register, R9);
REGISTER_DEFINITION(Register, R10);
REGISTER_DEFINITION(Register, R11);
REGISTER_DEFINITION(Register, R12);
REGISTER_DEFINITION(Register, R13);
REGISTER_DEFINITION(Register, R14);
REGISTER_DEFINITION(Register, R15);
REGISTER_DEFINITION(Register, R16);
REGISTER_DEFINITION(Register, R17);
REGISTER_DEFINITION(Register, R18);
REGISTER_DEFINITION(Register, R19);
REGISTER_DEFINITION(Register, R20);
REGISTER_DEFINITION(Register, R21);
REGISTER_DEFINITION(Register, R22);
REGISTER_DEFINITION(Register, R23);
REGISTER_DEFINITION(Register, R24);
REGISTER_DEFINITION(Register, R25);
REGISTER_DEFINITION(Register, R26);
REGISTER_DEFINITION(Register, R27);
REGISTER_DEFINITION(Register, R28);
REGISTER_DEFINITION(Register, R29);
REGISTER_DEFINITION(Register, R30);
REGISTER_DEFINITION(Register, R31);

REGISTER_DEFINITION(FloatRegister, fnoreg);

REGISTER_DEFINITION(FloatRegister, F0);
REGISTER_DEFINITION(FloatRegister, F1);
REGISTER_DEFINITION(FloatRegister, F2);
REGISTER_DEFINITION(FloatRegister, F3);
REGISTER_DEFINITION(FloatRegister, F4);
REGISTER_DEFINITION(FloatRegister, F5);
REGISTER_DEFINITION(FloatRegister, F6);
REGISTER_DEFINITION(FloatRegister, F7);
REGISTER_DEFINITION(FloatRegister, F8);
REGISTER_DEFINITION(FloatRegister, F9);
REGISTER_DEFINITION(FloatRegister, F10);
REGISTER_DEFINITION(FloatRegister, F11);
REGISTER_DEFINITION(FloatRegister, F12);
REGISTER_DEFINITION(FloatRegister, F13);
REGISTER_DEFINITION(FloatRegister, F14);
REGISTER_DEFINITION(FloatRegister, F15);
REGISTER_DEFINITION(FloatRegister, F16);
REGISTER_DEFINITION(FloatRegister, F17);
REGISTER_DEFINITION(FloatRegister, F18);
REGISTER_DEFINITION(FloatRegister, F19);
REGISTER_DEFINITION(FloatRegister, F20);
REGISTER_DEFINITION(FloatRegister, F21);
REGISTER_DEFINITION(FloatRegister, F22);
REGISTER_DEFINITION(FloatRegister, F23);
REGISTER_DEFINITION(FloatRegister, F24);
REGISTER_DEFINITION(FloatRegister, F25);
REGISTER_DEFINITION(FloatRegister, F26);
REGISTER_DEFINITION(FloatRegister, F27);
REGISTER_DEFINITION(FloatRegister, F28);
REGISTER_DEFINITION(FloatRegister, F29);
REGISTER_DEFINITION(FloatRegister, F30);
REGISTER_DEFINITION(FloatRegister, F31);


// ABI aliases

//REGISTER_DEFINITION(Register, R0);
REGISTER_DEFINITION(Register, AT);
REGISTER_DEFINITION(Register, V0);
REGISTER_DEFINITION(Register, V1);
REGISTER_DEFINITION(Register, A0);
REGISTER_DEFINITION(Register, A1);
REGISTER_DEFINITION(Register, A2);
REGISTER_DEFINITION(Register, A3);
REGISTER_DEFINITION(Register, A4);
REGISTER_DEFINITION(Register, A5);
REGISTER_DEFINITION(Register, A6);
REGISTER_DEFINITION(Register, A7);
REGISTER_DEFINITION(Register, T0);
REGISTER_DEFINITION(Register, T1);
REGISTER_DEFINITION(Register, T2);
REGISTER_DEFINITION(Register, T3);
REGISTER_DEFINITION(Register, S0);
REGISTER_DEFINITION(Register, S1);
REGISTER_DEFINITION(Register, S2);
REGISTER_DEFINITION(Register, S3);
REGISTER_DEFINITION(Register, S4);
REGISTER_DEFINITION(Register, S5);
REGISTER_DEFINITION(Register, S6);
REGISTER_DEFINITION(Register, S7);
REGISTER_DEFINITION(Register, T8);
REGISTER_DEFINITION(Register, T9);
REGISTER_DEFINITION(Register, K0);
REGISTER_DEFINITION(Register, K1);
REGISTER_DEFINITION(Register, GP);
REGISTER_DEFINITION(Register, SP);
REGISTER_DEFINITION(Register, FP);
REGISTER_DEFINITION(Register, RA);


// VM aliases

REGISTER_DEFINITION(Register, Rthread);
REGISTER_DEFINITION(Register, Rexception);
REGISTER_DEFINITION(Register, Rissuing_pc);
REGISTER_DEFINITION(Register, Rargs);
REGISTER_DEFINITION(Register, Rmethod_call);
REGISTER_DEFINITION(Register, Rlast_SP);

REGISTER_DEFINITION(Register, Rtos);
REGISTER_DEFINITION(Register, Rtos2);
REGISTER_DEFINITION(FloatRegister, Ftos);
REGISTER_DEFINITION(Register, Rsave0);
REGISTER_DEFINITION(Register, Rmethod);
REGISTER_DEFINITION(Register, Rlocals);
REGISTER_DEFINITION(Register, Rmonitors);
REGISTER_DEFINITION(Register, Resp);
REGISTER_DEFINITION(Register, Rbcp);
REGISTER_DEFINITION(Register, RcpoolCache);
REGISTER_DEFINITION(Register, Rbyte_code);
REGISTER_DEFINITION(Register, Rscratch0);
REGISTER_DEFINITION(Register, Rscratch1);
REGISTER_DEFINITION(Register, Rscratch2);
REGISTER_DEFINITION(Register, Rscratch3);
REGISTER_DEFINITION(Register, Rscratch4);
REGISTER_DEFINITION(Register, Rscratch5);
REGISTER_DEFINITION(FloatRegister, Fscratch0);
REGISTER_DEFINITION(FloatRegister, Fscratch1);
REGISTER_DEFINITION(FloatRegister, Fscratch2);
REGISTER_DEFINITION(FloatRegister, Fscratch3);
