#ifdef USE_PRAGMA_IDENT_HDR
#pragma ident "@(#)templateTable_sparc.hpp	1.19 07/05/05 17:04:31 JVM"
#endif
/*
 * Copyright 1998-2002 Sun Microsystems, Inc.  All Rights Reserved.
 * Copyright 2007-2008 Reservoir Labs, Inc.  All Rights Reserved.
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
 *
 * This code is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License version 2 only, as
 * published by the Free Software Foundation.
 *
 * This code is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 * version 2 for more details (a copy is included in the LICENSE file that
 * accompanied this code).
 *
 * You should have received a copy of the GNU General Public License version
 * 2 along with this work; if not, write to the Free Software Foundation,
 * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
 *
 * Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa Clara,
 * CA 95054 USA or visit www.sun.com if you need additional information or
 * have any questions.
 *  
 */

// #included by ../../../share/vm/interpreter/templateTable.hpp

  // helper function
  static void invokevfinal_helper(Register Rscratch, Register Rret);
  static void invokeinterface_object_method(Register RklassOop,
					    Register Rinterface,
					    Register Rret,
					    Register Rflags);
  static void generate_vtable_call(Register Rrecv, Register Rindex, Register Rret);
  static void volatile_barrier();

 protected:
  // helper: bne with comparison against an immediate
  static void bnei(Register rs, int imm32, Label& L, Register rtemp) {
    _masm-> li(rtemp, imm32);
    _masm-> bne(rs, rtemp, L);
  }

  static void bnei(Register rs, TosState ts, Label& L, Register rtemp) {
    bnei(rs, (int)ts, L, rtemp);
  }

  static void fcmp(int unordered_result);
  static void dcmp(int unordered_result);
