#ifdef USE_PRAGMA_IDENT_SRC
#pragma ident "@(#)assembler_linux_amd64.cpp	1.9 07/06/19 09:08:09 JVM"
#endif
/*
 * Copyright 2003 Sun Microsystems, Inc.  All Rights Reserved.
 * Copyright 2007-2008 Reservoir Labs, Inc.  All Rights Reserved.
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
 *
 * This code is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License version 2 only, as
 * published by the Free Software Foundation.
 *
 * This code is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 * version 2 for more details (a copy is included in the LICENSE file that
 * accompanied this code).
 *
 * You should have received a copy of the GNU General Public License version
 * 2 along with this work; if not, write to the Free Software Foundation,
 * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
 *
 * Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa Clara,
 * CA 95054 USA or visit www.sun.com if you need additional information or
 * have any questions.
 *  
 */

#include "incls/_precompiled.incl"
#include "incls/_assembler_linux_mips.cpp.incl"

void MacroAssembler::get_thread(Register thread) {
  // call pthread_getspecific
  // void * pthread_getspecific(pthread_key_t key);

  save_frame();
  li(A0, ThreadLocalStorage::thread_index());
  jal_to_C(CAST_FROM_FN_PTR(address, pthread_getspecific), 
	   relocInfo::runtime_call_type);
  delayed()->nop();
  restore_frame();
  move(thread, V0);
}

// NOTE: since the linux kernel resides at the low end of
// user address space, no null pointer check is needed.
// YYY: we need to check the exact range for MIPS.
bool MacroAssembler::needs_explicit_null_check(int offset) {
  return offset != 0;
}
